/**
* enopm helped me with this script! 
*/

import { world, Player } from "@minecraft/server"

world.afterEvents.entityHurt.subscribe(async ({ damageSource: { damagingEntity: attacker }, hurtEntity: target }) => {
  if (!(attacker instanceof Player) || !target.hasComponent("minecraft:health")) return;
  const health = target.getComponent("minecraft:health");
  if (health.currentValue > 0) {
    await attacker.runCommandAsync("event entity @s hitmarker");
  } else {
    await attacker.runCommandAsync("event entity @s hitmarker_kill");
  }
});